ALTER PROCEDURE "dba"."pv_korrigeeri_koik"( in a_par char(40),in a_id1 integer, in a_s1 char(100) )
BEGIN
  declare ll_pos integer;
  set ll_pos=Locate(a_par,'_NULL');
  if ll_pos>1 then
    set a_id1=null;
    set a_s1=null;
    set a_par=Left(a_par,ll_pos-1);
  end if;
  case a_par
    when 'KandedKorrastadaKontod' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."konto"=a_s1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaDeebet' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."deebet"=a_s1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKreedit' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."kreedit"=a_s1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaMeetmed' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."meetnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKuluobjektid' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."kulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevusalad' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."talnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKululiigid' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."artnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTululiigid' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."tulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaProjektid' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."objectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaOsakonnad' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."osaknr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaSubjektid' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."subjectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevussuunad' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."suundnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTaotlused' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."taotnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaAllikad' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."alliknr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaRahavood' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."ravonr"=a_id1 where "gl_selectall"."id1" is not null
    when 'kor_tunnus' then
      update "pv_kanne" left outer join "gl_selectall" on "pv_kanne"."id"="gl_selectall"."id1"
        set "pv_kanne"."tunnus"=a_s1 where "gl_selectall"."id1" is not null
  end case;
END